Désinstallation apache2

Bonjour,

j’avais désinstallé apache2 avant et je désirerais le réinstaller.

Je fais un :

mais je n’ai plus le script d’init dans /etc/init.d/. Y a t’il un moyen de le récupérer ?

Tu n’as même pas le fichier /etc/init.d/apache2.dpkg-dist ?

Voici le contenu du mien (jamais modifié ni testé, d’où le dpkg-dist, il faudrait d’ailleurs que je désinstalle apache) :

[code]#!/bin/sh -e

BEGIN INIT INFO

Provides: apache2

Required-Start: $local_fs $remote_fs $network $syslog

Required-Stop: $local_fs $remote_fs $network $syslog

Default-Start: 2 3 4 5

Default-Stop: 0 1 6

Short-Description: Start/stop apache2 web server

END INIT INFO

apache2 This init.d script is used to start apache2.

It basically just calls apache2ctl.

ENV=“env -i LANG=C PATH=/usr/local/bin:/usr/bin:/bin”

#[ $(ls -1 /etc/apache2/sites-enabled/ | wc -l | sed -e ‘s/ *//;’) -eq 0 ] &&
#echo “You haven’t enabled any sites yet, so I’m not starting apache2.” &&
#echo “To add and enable a host, use addhost and enhost.” && exit 0

#edit /etc/default/apache2 to change this.
HTCACHECLEAN_RUN=auto
HTCACHECLEAN_MODE=daemon
HTCACHECLEAN_SIZE=300M
HTCACHECLEAN_DAEMON_INTERVAL=120
HTCACHECLEAN_PATH=/var/cache/apache2/mod_disk_cache
HTCACHECLEAN_OPTIONS=""

set -e
if [ -x /usr/sbin/apache2 ] ; then
HAVE_APACHE2=1
else
echo "No apache MPM package installed"
exit 0
fi

. /lib/lsb/init-functions

test -f /etc/default/rcS && . /etc/default/rcS
test -f /etc/default/apache2 && . /etc/default/apache2

APACHE2CTL="$ENV /usr/sbin/apache2ctl"
HTCACHECLEAN="$ENV /usr/sbin/htcacheclean"

PIDFILE=$(. /etc/apache2/envvars && echo $APACHE_PID_FILE)
if [ -z “$PIDFILE” ] ; then
echo ERROR: APACHE_PID_FILE needs to be defined in /etc/apache2/envvars >&2
exit 2
fi

check_htcacheclean() {
[ “$HTCACHECLEAN_MODE” = “daemon” ] || return 1

    [ "$HTCACHECLEAN_RUN"  = "yes"    ] && return 0

    [ "$HTCACHECLEAN_RUN"  = "auto" \
      -a -e /etc/apache2/mods-enabled/disk_cache.load ] && return 0

    return 1

}

start_htcacheclean() {
$HTCACHECLEAN $HTCACHECLEAN_OPTIONS -d$HTCACHECLEAN_DAEMON_INTERVAL
-i -p$HTCACHECLEAN_PATH -l$HTCACHECLEAN_SIZE

}

stop_htcacheclean() {
killall htcacheclean 2> /dev/null || echo …not running
}

pidof_apache() {
# if pidof is null for some reasons the script exits automagically
# classified as good/unknown feature
PIDS=$(pidof apache2) || true

[ -e $PIDFILE ] && PIDS2=$(cat $PIDFILE)

# if there is a pid we need to verify that belongs to apache2
# for real
for i in $PIDS; do
    if [ "$i" = "$PIDS2" ]; then
        # in this case the pid stored in the
        # pidfile matches one of the pidof apache
        # so a simple kill will make it
        echo $i
        return 0
    fi
done
return 1

}

apache_stop() {
if $APACHE2CTL configtest > /dev/null 2>&1; then
# if the config is ok than we just stop normaly
$APACHE2CTL stop 2>&1 | grep -v ‘not running’ >&2 || true
else
# if we are here something is broken and we need to try
# to exit as nice and clean as possible
PID=$(pidof_apache)

            if [ "${PID}" ]; then
                    # in this case it is everything nice and dandy
                    # and we kill apache2
                    log_warning_msg "We failed to correctly shutdown apache, so we're now killing all running apache processes. This is almost certainly suboptimal, so please make sure your system is working as you'd expect now!"
                    kill $PID
            elif [ "$(pidof apache2)" ]; then
                    if [ "$VERBOSE" != no ]; then
                            echo " ... failed!"
                            echo "You may still have some apache2 processes running.  There are"
                            echo "processes named 'apache2' which do not match your pid file,"
                            echo "and in the name of safety, we've left them alone.  Please review"
                            echo "the situation by hand."
                    fi
                    return 1
            fi
    fi

}

apache_wait_stop() {
# running ?
PIDTMP=$(pidof_apache)
if kill -0 “${PIDTMP:-}” 2> /dev/null; then
PID=$PIDTMP
fi

    apache_stop

    # wait until really stopped
    if [ -n "${PID:-}" ]; then
            i=0
            while kill -0 "${PID:-}" 2> /dev/null;  do
                    if [ $i = '60' ]; then
                            break;
                    else
                            if [ $i = '0' ]; then
                                    echo -n " ... waiting "
                            else
                                    echo -n "."
                            fi
                            i=$(($i+1))
                            sleep 1
                  fi
             done
    fi

}

case $1 in
start)
log_daemon_msg “Starting web server” "apache2"
if $APACHE2CTL start; then
if check_htcacheclean ; then
log_progress_msg htcacheclean
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
stop)
if check_htcacheclean ; then
log_daemon_msg “Stopping web server” "htcacheclean"
stop_htcacheclean
log_progress_msg "apache2"
else
log_daemon_msg “Stopping web server” "apache2"
fi
if apache_wait_stop; then
log_end_msg 0
else
log_end_msg 1
fi
;;
reload | force-reload)
if ! $APACHE2CTL configtest > /dev/null 2>&1; then
$APACHE2CTL configtest || true
log_end_msg 1
exit 1
fi
log_daemon_msg “Reloading web server config” "apache2"
if pidof_apache > /dev/null ; then
if $APACHE2CTL graceful $2 ; then
log_end_msg 0
else
log_end_msg 1
fi
fi
;;
restart)
if check_htcacheclean ; then
log_daemon_msg “Restarting web server” "htcacheclean"
stop_htcacheclean
log_progress_msg apache2
else
log_daemon_msg “Restarting web server” "apache2"
fi
PID=$(pidof_apache) || true
if ! apache_wait_stop; then
log_end_msg 1 || true
fi
if $APACHE2CTL start; then
if check_htcacheclean ; then
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
start-htcacheclean)
log_daemon_msg "Starting htcacheclean"
start_htcacheclean || log_end_msg 1
log_end_msg 0
;;
stop-htcacheclean)
log_daemon_msg "Stopping htcacheclean"
stop_htcacheclean
log_end_msg 0
;;
status)
PID=$(pidof_apache)
if [ -n “$PID” ]; then
log_success_msg "Apache is running (pid $PID)."
exit 0
else
log_failure_msg "Apache is not running."
exit 1
fi
;;
*)
log_success_msg "Usage: /etc/init.d/apache2 {start|stop|restart|reload|force-reload|start-htcacheclean|stop-htcacheclean|status}"
exit 1
;;
esac[/code]

Merci de ton aide mais non je n’ai pas de fichier.

J’ai le dossier apache2 dans /etc.

Tu peux utiliser celui que je t’ai donné.

Oui c’est se que j’ai fait.

Après un reboot ce fichier avait disparu. Est-ce normal?

Oui c’est se que j’ai fait.

Après un reboot ce fichier avait disparu. Est-ce normal?[/quote]
Euh, Joker :laughing:

As-tu exécuté cette commande après avoir créé le fichier : update-rc.d apache2 start ?

Oui c’est se que j’ai fait.

Après un reboot ce fichier avait disparu. Est-ce normal?[/quote]
Euh, Joker :laughing:

As-tu exécuté cette commande après avoir créé le fichier : update-rc.d apache2 start ?[/quote]

Non mais par contre je progresse =) (enfin…)

J’ai le trouvé un script pour apache2 :

[code]#!/bin/sh -e

Nécessaire pour exécuter tous les hôtes virtuels

ulimit -n 20000

BEGIN INIT INFO

Provides: apache2

Required-Start: $local_fs $remote_fs $network $syslog

Required-Stop: $local_fs $remote_fs $network $syslog

Default-Start: 2 3 4 5

Default-Stop: 0 1 6

Short-Description: Start/stop apache2 web server

END INIT INFO

apache2 This init.d script is used to start apache2.

It basically just calls apache2ctl.

ENV=“env -i LANG=C PATH=/usr/local/bin:/usr/bin:/bin”

#[ ls -1 /etc/apache2/sites-enabled/ | wc -l | sed -e 's/ *//;' -eq 0 ] &&
#echo “You haven’t enabled any sites yet, so I’m not starting apache2.” &&
#echo “To add and enable a host, use addhost and enhost.” && exit 0

#edit /etc/default/apache2 to change this.
HTCACHECLEAN_RUN=auto
HTCACHECLEAN_MODE=daemon
HTCACHECLEAN_SIZE=300M
HTCACHECLEAN_DAEMON_INTERVAL=120
HTCACHECLEAN_PATH=/var/cache/apache2/mod_disk_cache
HTCACHECLEAN_OPTIONS=""

set -e
if [ -x /usr/sbin/apache2 ] ; then
HAVE_APACHE2=1
else
echo "No apache MPM package installed"
exit 0
fi

. /lib/lsb/init-functions

test -f /etc/default/rcS && . /etc/default/rcS
test -f /etc/default/apache2 && . /etc/default/apache2

APACHE2CTL="$ENV /usr/sbin/apache2ctl"
HTCACHECLEAN="$ENV /usr/sbin/htcacheclean"

check_htcacheclean() {
[ “$HTCACHECLEAN_MODE” = “daemon” ] || return 1

[ "$HTCACHECLEAN_RUN"  = "yes"    ] && return 0

[ "$HTCACHECLEAN_RUN"  = "auto" \
  -a -e /etc/apache2/mods-enabled/disk_cache.load ] && return 0

return 1

}

start_htcacheclean() {
$HTCACHECLEAN $HTCACHECLEAN_OPTIONS -d$HTCACHECLEAN_DAEMON_INTERVAL
-i -p$HTCACHECLEAN_PATH -l$HTCACHECLEAN_SIZE

}

stop_htcacheclean() {
killall htcacheclean 2> /dev/null || echo …not running
}

pidof_apache() {
# if pidof is null for some reasons the script exits automagically
# classified as good/unknown feature
PIDS=pidof apache2 || true

PFILE=`. /etc/apache2/envvars ; echo $APACHE_PID_FILE`
if [ -z "$PFILE" ] ; then
	echo ERROR: APACHE_PID_FILE needs to be defined in /etc/apache2/envvars >&2
exit 2
fi

[ -e $PFILE ] && PIDS2=`cat $PFILE`

# if there is a pid we need to verify that belongs to apache2
# for real
for i in $PIDS; do
	if [ "$i" = "$PIDS2" ]; then
        # in this case the pid stored in the
        # pidfile matches one of the pidof apache
        # so a simple kill will make it
        echo $i
        return 0
    fi
done
return 1

}

apache_stop() {
if $APACHE2CTL configtest > /dev/null 2>&1; then
# if the config is ok than we just stop normaly
$APACHE2CTL graceful-stop
else
# if we are here something is broken and we need to try
# to exit as nice and clean as possible
PID=$(pidof_apache)

	if [ "${PID}" ]; then
		# in this case it is everything nice and dandy
		# and we kill apache2
		log_warning_msg "We failed to correctly shutdown apache, so we're now killing all running apache processes. This is almost certainly suboptimal, so please make sure your system is working as you'd expect now!"
                    kill $PID
	elif [ "$(pidof apache2)" ]; then
		if [ "$VERBOSE" != no ]; then
                            echo " ... failed!"
		        echo "You may still have some apache2 processes running.  There are"
		        echo "processes named 'apache2' which do not match your pid file,"
		        echo "and in the name of safety, we've left them alone.  Please review"
		        echo "the situation by hand."
                    fi
                    return 1
	fi
fi

}

Stupid hack to keep lintian happy. (Warrk! Stupidhack!).

case $1 in
start)
log_daemon_msg “Starting web server” "apache2"
if $APACHE2CTL start; then
if check_htcacheclean ; then
log_progress_msg htcacheclean
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
stop)
if check_htcacheclean ; then
log_daemon_msg “Stopping web server” "htcacheclean"
stop_htcacheclean
log_progress_msg "apache2"
else
log_daemon_msg “Stopping web server” "apache2"
fi
if apache_stop; then
log_end_msg 0
else
log_end_msg 1
fi
;;
reload | force-reload)
if ! $APACHE2CTL configtest > /dev/null 2>&1; then
$APACHE2CTL configtest || true
log_end_msg 1
exit 1
fi
log_daemon_msg “Reloading web server config” "apache2"
if pidof_apache > /dev/null ; then
if $APACHE2CTL graceful $2 ; then
log_end_msg 0
else
log_end_msg 1
fi
fi
;;
restart)
if check_htcacheclean ; then
log_daemon_msg “Restarting web server” "htcacheclean"
stop_htcacheclean
log_progress_msg apache2
else
log_daemon_msg “Restarting web server” "apache2"
fi
if ! apache_stop; then
log_end_msg 1 || true
fi
sleep 10
if $APACHE2CTL start; then
if check_htcacheclean ; then
start_htcacheclean || log_end_msg 1
fi
log_end_msg 0
else
log_end_msg 1
fi
;;
start-htcacheclean)
log_daemon_msg "Starting htcacheclean"
start_htcacheclean || log_end_msg 1
log_end_msg 0
;;
stop-htcacheclean)
log_daemon_msg "Stopping htcacheclean"
stop_htcacheclean
log_end_msg 0
;;
*)
log_success_msg "Usage: /etc/init.d/apache2 {start|stop|restart|reload|force-reload|start-htcacheclean|stop-htcacheclean}"
exit 1
;;
esac

[/code]

Je l’ai donc utilisé pour lancer apache2 :

Et voila l’erreur retournée :

Starting web server: apache2apache2: apr_sockaddr_info_get() failed for debian-toad apache2: Could not reliably determine the server's fully qualified domain name, using 127.0.0.1 for ServerName httpd (pid 8468) already running .

C’est un pas en avant non? :wink:

EDIT :

disparaît avec un kill 8468 :wink:

Bah ça veut dire qu’apache tourne déjà.
Si tu fais ps -ef | grep apache, tu devrais voir le processsus tourner.

Tu peux essayer, pour t’assurer du bon fonctionnement du script, de l’arrêter, et le démarrer, ou le redémarrer tout simplement :

[code]/etc/init.d/apache2 stop ; /etc/init.d/apache2 start

ou

/etc/init.d/apache2 restart[/code]

Tu peux utiliser la méthode bourrin :

# apt-get install apache2 --purge --reinstall

[quote=“debianhadic”]Tu peux utiliser la méthode bourrin :

# apt-get install apache2 --purge --reinstall
[/code][/quote]

Merci,

voila :

[code]La réinstallation de apache2 est impossible, il ne peut pas être téléchargé.
0 mis à jour, 0 nouvellement installés, 0 à enlever et 21 non mis à jour.

Je vais essayer de corriger le problème.

EDIT : après un aptitude remove apache2, ta commande fonctionne mais j’ai toujours la même erreur.

EDIT : un ps -ejH retourne le processus apache2 et tous ses processus esclaves. Même en “killant” ce groupe l’erreur subsiste.

EDIT : (oui je sais ça commence à faire beaucoup) les commandes /etc/init.d/apache2 start | stop | restart fonctionnent (je vois ça en lisant les processus). Dois-je passer outre l’erreur retournée ?

EDIT : j’ai trouvé ce topic : ubuntuforums.org/showthread.php?t=458839

et j’ai relevé ce message :

[quote]Yes, it is normal for httpd.conf to be empty because ubuntu uses apache2.conf instead.

You sound like you have a network problem, test localhost to see if apache works first.

It is likely the public cannot access your server because your ports are closed.

Good luck[/quote]

Je ne suis pas très bon en anglais mais j’ai cru comprendre que je devais tester mon serveur apache2 en ouvrant localhost. Mon serveur à l’air de fonctionner.

Plus loin dans le même topic, quelqu’un à parler du fichier /etc/hosts. J’ai aussi un message concernant ce fichier, je vous poste donc le contenu du mien (je l’avais un peu trituré pour mettre en place en routeur sur ma machine à l’époque) :

[code]127.0.0.1 localhost

The following lines are desirable for IPv6 capable hosts

::1 localhost ip6-localhost ip6-loopback
fe00::0 ip6-localnet
ff00::0 ip6-mcastprefix
ff02::1 ip6-allnodes
ff02::2 ip6-allrouters
ff02::3 ip6-allhosts
[/code]